/**
   File name: entity.cpp
   Ex number: Project, part 1
   Login: adiluria
   Name: Adi Luria
   ID: 017651662
*/

#include "entity.h"

Entity::Entity(unsigned int order, unsigned int xPos,
	       unsigned int yPos):_order(order),_xPos(xPos),
				  _yPos(yPos),_isAlive(true),
				  _isBusy(false){
  if(!Checks<unsigned int>::checkStrictlyPositive(_xPos)||
     !Checks<unsigned int>::checkStrictlyPositive(_yPos))
    throw IllegalEntityException(_order);
}

void Entity::setXPos(unsigned int xPos) {
      if(!Checks<unsigned int>::checkStrictlyPositive(xPos))
		  throw IllegalEntityException(_order);
      _xPos = xPos;
}

void Entity::setYPos(unsigned int yPos) {
      if(!Checks<unsigned int>::checkStrictlyPositive(yPos))
	    throw IllegalEntityException(_order);
      _yPos = yPos;
}

ostream& Entity::stringFormat(ostream& out)const{
      return out<< _XPOS << _SPACE << _EQUALS << _SPACE << _xPos<< _SPACE <<
	    _YPOS<< _SPACE << _EQUALS << _SPACE << _yPos << _SPACE;
}

/*---------------------- consts -------------------------------------*/
// defines the string repres. of the fields of the entity
const string Entity::_ORDER = "order";
const string Entity::_XPOS = "xpos";
const string Entity::_YPOS = "ypos";

const string Entity::_SPACE = " ";
const string Entity::_EQUALS = "=";
const string Entity::_OPEN = "{";
const string Entity::_CLOSE = "}";

/************************************************************************
			       EOF
*************************************************************************/

