/**
   File name: event.h
   Ex number: Project, part 2
   Login: adiluria
   Name: Adi Luria
   ID: 017651662

   File description: Defines an event. It is the base class of the
   event hierarchy. The method process recieves a ref to a simulation so
   it can schedule events in the event-queue.
*/

#ifndef _EVENT_H
#define _EVENT_H

/*------------------------ forward declarations -----------------------*/
class Simulation;

#include <iostream>

class Event{
 public:
      /* constructs an event with the given time. */ 
  Event(float t):_time(t){}

        /* dtor */
      virtual ~Event(){}

      /* processes the event. */
      virtual void process(Simulation& sim) = 0;

      /* returns the current time. */
      float time()const {return _time;}

 private:

      // denotes the time of the event
      float _time;
};
#endif

/*************************************************************************
			       EOF
*************************************************************************/

