/**
   File name: exception.h
   Ex number: Project, part 1
   Login: adiluria
   Name: Adi Luria
   ID: 017651662

   File description: class defining a generic exception. It is the
   base class of the exception hierarchy.
*/

#ifndef _EXCEPTION_H
#define _EXCEPTION_H

static const string _MESSAGE = "Error in the program.";

class Exception{
 public:
      /*--------------------- ctors --------------------------------*/

      /*------------------------------------------------------------
	default ctor
      -------------------------------------------------------------*/
      Exception():_message(_MESSAGE){}

      /*------------------------------------------------------------
	defines a ctor which recives a string as the error message.
      -------------------------------------------------------------*/
      Exception(const string& message):_message(message){}
      
      /* returns the error message of this exception.*/
      const string getMessage()const {return _message;}

      void setMessage(const string& message){_message = message;}
 protected:
      /* denotes the error message of the exception. */
      string _message;
};
#endif

/*************************************************************************
			       EOF
**************************************************************************/

