/**
   File name: flower.h
   Ex number: Project, part 1
   Login: adiluria
   Name: Adi Luria
   ID: 017651662

   File description: This class defines a flower which inherits the
   plant family class. a flower is defined by all the params which
   are defined in the plant family class.
*/

#ifndef _FLOWER_H
#define _FLOWER_H

/*------------------- included files ------------------------------*/
#include <iostream.h>
#include <string>
#include "plantFamily.h"

class Flower: public PlantFamily{
 public:
      /*---------------- ctors ------------------------------------*/
      /* default ctor */
      Flower(){}
      /* constructs a flower using a plant family ctor. */
      Flower(unsigned int order, unsigned int xPos,
	     unsigned int yPos, float lifetime,
	     float seedingTime,  float airialTime,
	     float floweringTime):
	    PlantFamily(order,xPos,yPos,lifetime,seedingTime,airialTime,
			floweringTime){}
      /*--------------------- dtor ---------------------------------*/
      ~Flower(){}

      /* returns the string repres. of the flower. */
      virtual ostream& stringFormat(ostream& out)const;

      /* defines the generic encounter method of the flower. */
      virtual void encounter(Entity* ent, EncounterManager& enc);

      /* defines the encounter of this flower with a student. */
      virtual void encounterStudent(Student* s, EncounterManager& enc);

      /* defines the encounter of this flower with a teacher. */
      virtual void encounterTeacher(Teacher* t, EncounterManager& enc);

      /* defines the encounter of this flower with a flower. */
      virtual void encounterFlower(Flower* f, EncounterManager& enc);

      /* defines the encounter of this flower with a flower-seed. */
      virtual void encounterSeed(Seed* s, EncounterManager& enc);

      /* defines the encounter of this flower with a mole-cricket. */
      virtual void encounterMole(Mole* m, EncounterManager& enc);

      // const denoting the flower param
      static const string _FLOWER;
};
#endif


/*************************************************************************
			       EOF
**************************************************************************/

