/**
   File name: illegalEntityException.h
   Ex number: Project, part 2
   Login: adiluria
   Name: Adi Luria
   ID: 017651662

   File description: class defining an illegal entity format
   exception in one of the enetities created.
   This exception is thrown if the format of the entity input is
   somehow illegal, yet the program is not exited.
*/

#ifndef _ILLEGAL_ENTITY_H
#define _ILLEGAL_ENTITY_H

/*----------------------- included files ---------------------------*/
#include "readerException.h"
#include <strstream>
#include <string>

static const string _ENTITY_MESSAGE =
"Illegal entity record for record no. ";

class IllegalEntityException: public ReaderException{
 public:
  /*----------------------- ctor --------------------------------*/
  
  /*--------------------------------------------------------------
    default ctor
    -------------------------------------------------------------*/
  IllegalEntityException():ReaderException(_ENTITY_MESSAGE){}

  /*-------------------------------------------------------------
    constructs an exception with the given order of the entity
    with the illegal params.
   -------------------------------------------------------------*/  
  IllegalEntityException(unsigned int order){
       	strstream temp;
	temp << order; 
	string number;
	temp >> number;
	setMessage(_ENTITY_MESSAGE + number);
  }
  
  /*--------------------------------------------------------------
    constructs an illegal entity exception, which is thrown when
    the format of the block of the entity is incorrect.
    -------------------------------------------------------------*/
  IllegalEntityException(const string& message):ReaderException(message){}

};

#endif

/************************************************************************
			       EOF
*************************************************************************/

