/**
   File name: mole.cpp
   Ex number: Project, part 2
   Login: adiluria
   Name: Adi Luria
   ID: 017651662

   File description:
*/

#include <string>
#include "mole.h"
#include "encounterManager.h"

Mole::Mole(unsigned int order, unsigned int xPos,
	   unsigned int yPos, float moveTime,
	   const string movePattern, float eatingTime):
  MovableEntity(order,xPos,yPos,moveTime,movePattern),
  _eatingTime(eatingTime){
  if(!Checks<float>::checkPositive(_eatingTime))
    throw IllegalEntityException(_order);
}

void Mole::setEatingTime(float eatingTime) {
  if(!Checks<float>::checkPositive(eatingTime))
		  throw IllegalEntityException(_order);
  _eatingTime=eatingTime;
}

ostream& Mole::stringFormat(ostream& out)const{
      ostream& tmp = out << _MOLE << _SPACE << _OPEN << _SPACE;

      // concating to the string repres. of the movableEntity.
      return (MovableEntity::stringFormat(tmp))
	<< _EAT_TIME << _SPACE << _EQUALS << _SPACE << _eatingTime
	<< _SPACE << _CLOSE << endl;
      return out;
}

void Mole::encounter(Entity* ent, EncounterManager& enc){
      ent->encounterMole(this, enc);
}

void Mole::encounterStudent(Student* s, EncounterManager& enc){}

void Mole::encounterTeacher(Teacher* t, EncounterManager& enc){}

void Mole::encounterFlower(Flower* f, EncounterManager& enc){
      enc.encounterMoleCricketAndFlower(this, f);
}

void Mole::encounterSeed(Seed* s, EncounterManager& enc){}

void Mole::encounterMole(Mole* m, EncounterManager& enc){}

const string Mole::_MOLE = "Mole-Cricket";
const string Mole::_EAT_TIME = "eating-time";

/*************************************************************************
			       EOF
*************************************************************************/



