/**
   File name: plantFamily.cpp
   Ex number: Project, part 2
   Login: adiluria
   Name: Adi Luria
   ID: 017651662
*/

#include "plantFamily.h"

PlantFamily::PlantFamily(unsigned int order, unsigned int xPos,
			 unsigned int yPos, float lifetime,
			 float seedingTime, float airialTime,
			 float floweringTime): 
  Entity(order,xPos,yPos),_lifetime(lifetime), _seedingTime(seedingTime),
  _airialTime(airialTime), _floweringTime(floweringTime){
  if(!Checks<float>::checkPositive(_lifetime) ||
     !Checks<float>::checkPositive(_seedingTime) ||
     !Checks<float>::checkPositive(_airialTime) ||
     !Checks<float>::checkPositive(_floweringTime))
    throw IllegalEntityException(_order);
}

void PlantFamily::setLifetime(float lifetime){
  if(!Checks<float>::checkPositive(_lifetime))
    throw IllegalEntityException(_order);
  _lifetime=lifetime;
}

void PlantFamily::setSeedingTime(float seedingTime){
  if(!Checks<float>::checkPositive(_seedingTime))
    throw IllegalEntityException(_order);
  _seedingTime=seedingTime;
}

void PlantFamily::setAirialTime(float airialTime){
  if(!Checks<float>::checkPositive(_airialTime))
    throw IllegalEntityException(_order);
  _airialTime=airialTime;
}

void PlantFamily::setFloweringTime(float floweringTime){
  if(!Checks<float>::checkPositive(_floweringTime))
    throw IllegalEntityException(_order);
  _floweringTime=floweringTime;
}


ostream& PlantFamily::stringFormat(ostream& out)const{
      // first appending the string repres of the plant with that of
      // the entity
      Entity::stringFormat(out) 
	<< _LIFETIME << _SPACE << _EQUALS << _SPACE << _lifetime
	<< _SPACE << _SEED_TIME << _SPACE << _EQUALS << _SPACE
	<< _seedingTime << _SPACE << _AIRIAL << _SPACE << _EQUALS << _SPACE
	<< _airialTime << _SPACE << _FLOW_TIME << _SPACE << _EQUALS << _SPACE
	<< _floweringTime << _SPACE;
      return out;
}

const string PlantFamily::_LIFETIME = "lifetime";
const string PlantFamily::_SEED_TIME = "seeding-time";
const string PlantFamily::_AIRIAL = "airial-time";
const string PlantFamily::_FLOW_TIME = "flowering-time";

/*************************************************************************
			       EOF
**************************************************************************/

