/**
   File name: plantFamily.h
   Ex number: Project, part 1
   Login: adiluria
   Name: Adi Luria
   ID: 017651662

   File description: defines a member of the plant family. It inherits
   the entity class. A plant family member defines the lifetime,
   seeding-time, airial-time and flowering-time of the member.
*/

#ifndef _PLANT_FAMILY_H
#define _PLANT_FAMILY_H

/*-------------------- included files ---------------------------------*/
#include <string>
#include "entity.h"

class PlantFamily: public Entity{
 public:
      /*----------------- ctors ---------------------------------------*/
      /* defines a default ctor. */
      PlantFamily(){}

      /* a ctor which is which is inited with the Entity base class,
	 initing the plant fields. */
      PlantFamily(unsigned int order, unsigned int xPos,
		  unsigned int yPos, float lifetime,
		  float seedingTime, float airialTime,
		  float floweringTime);

      /*-------------- dtor ------------------------------------------*/
      virtual ~PlantFamily(){}

      /*---------------------- accessories ---------------------------*/

      /* gets the lifetime of the plant */
      float getLifetime()const {return(_lifetime);}

      /* sets the lifetime of the plant. */
      void setLifetime(float lifetime);

      /* gets the seeding-time of the plant */
      float getSeedingTime()const {return(_seedingTime);}

      /* sets the seeding-time of the plant. */
      void setSeedingTime(float seedingTime);

      /* gets the airial-time of the plant */
      float getAirialTime()const {return _airialTime;}

      /* sets the airial-time of the plant. */
      void setAirialTime(float airialTime);

      /* gets the flowering-time of the plant */
      float getFloweringTime()const {return(_floweringTime);}

      /* sets the airial-time of the plant. */
      void setFloweringTime(float floweringTime);

      /* returns the string repres of the plant family member in the
	 form of an ostream. */
      virtual ostream& stringFormat(ostream& out)const;

      /*--------------- consts --------------------------------------------*/
      // const defining the string repres. of the fields.
      static const string _LIFETIME;
      static const string _SEED_TIME;
      static const string _AIRIAL;
      static const string _FLOW_TIME;
      
 private:
      // denotes the lifetime of the plant
      float _lifetime;
      // denotes the seeding-etime of the plant
      float _seedingTime;
      // denotes the airial-time of the plant
      float _airialTime;
      // denotes the flowering-time of the plant
      float _floweringTime;
};
#endif

/*************************************************************************
			       EOF
**************************************************************************/

