/**
   File name: point.h
   Ex number: Project, part 2
   Login: adiluria
   Name: Adi Luria
   ID: 017651662

   File description: This class defines a 2 dimensional point,
   on an x, y grid.
*/

#ifndef _POINT_H
#define _POINT_H

#include <string>
#include <strstream>

class Point{
 public:
      /*-------------------- ctors ----------------------------------------*/
      /* default ctor. sets the point to be (0,0). */
      Point():_xpos(0),_ypos(0){}

      /* sets the point with the given coordinates. */
      Point(unsigned int xpos, unsigned int ypos):_xpos(xpos), _ypos(ypos){}

      /* copy ctor */
      Point(const Point& p): _xpos(p._xpos), _ypos(p._ypos){}

      /*--------------------------- dtor ----------------------------------*/
      ~Point(){}
      /*------------------------ accessories ------------------------------*/

      /* returns the x coor of the point. */
      unsigned int getX()const {return _xpos;}

      /* returns the y coor of the point. */
      unsigned int getY()const {return _ypos;}

      /* sets the x coor of the point. */
      void setX(unsigned int xpos) {_xpos = xpos;}

      /* sets the y coor of the point. */
      void setY(unsigned int ypos) {_ypos = ypos;}
      
      /* returns true if the given point equals this point, by value. */
      bool operator==(const Point& p)const;
 
      bool operator< (const Point& p)const;

      /* returns the string repres. of the point in the format of 
       "xpos , ypos" */
      //const string stringFormat()const;
       
      // the seperator in the string representation    
      static const string _SEPARATOR;
 private:
      // denotes x pos.
      unsigned int _xpos;
      // denotes y pos.
      unsigned int _ypos;
};

ostream& operator<<(ostream& out,const Point& p);

#endif

/*************************************************************************
			       EOF
**************************************************************************/
