/**
   File name: seed.h
   Ex number: Project, part 1
   Login: adiluria
   Name: Adi Luria
   ID: 017651662

   File description:  This class defines a flower-seed which inherits the
   plant family class. the flower-seed is defined by all the params which
   are defined in the plant family class.
*/

#ifndef _SEED_H
#define _SEED_H

/*------------------- included files ------------------------------*/
#include <iostream.h>
#include <string>
#include "plantFamily.h"

class Seed: public PlantFamily{
 public:
      /*---------------- ctors ------------------------------------*/
      /* default ctor */
      Seed(){}
      /* constructs a flower-seed using a plant family ctor. */
      Seed(unsigned int order,unsigned int xPos,
	   unsigned int yPos, float liftime,
	   float seedingTime, float airialTime,
	   float floweringTime):
	PlantFamily(order,xPos,yPos,liftime,seedingTime,airialTime,
		    floweringTime){}
      
      /*--------------------- dtor ---------------------------------*/
      ~Seed(){}

      /* returns the string repres. of the flower-seed. */
      virtual ostream& stringFormat(ostream& out)const;

      /* defines the generic encounter method of the flower-seed. */
      virtual void encounter(Entity* ent, EncounterManager& enc);

      /* defines the encounter of this flower-seed with a student. */
      virtual void encounterStudent(Student* s, EncounterManager& enc);

      /* defines the encounter of this flower-seed with a teacher. */
      virtual void encounterTeacher(Teacher* t, EncounterManager& enc);

      /* defines the encounter of this flower-seed with a flower. */
      virtual void encounterFlower(Flower* f, EncounterManager& enc);

      /* defines the encounter of this flower-seed with a flower-seed. */
      virtual void encounterSeed(Seed* s, EncounterManager& enc);

      /* defines the encounter of this flower-seed with a mole-cricket. */
      virtual void encounterMole(Mole* m, EncounterManager& enc);

      // const denoting the flower-seed param
      static const string _SEED;
};
#endif

/*************************************************************************
			       EOF
**************************************************************************/

