/**
   File name: student.cpp
   Ex number: Project, part 1
   Login: adiluria
   Name: Adi Luria
   ID: 017651662
*/

#include <string>
#include "student.h"
#include "encounterManager.h"

Student::Student(unsigned int order, unsigned int xPos,
		 unsigned int yPos, float moveTime,
		 const string movePattern, unsigned int numFlowers,
		 float pickTime, const string gameStrategy):
      MovableEntity(order,xPos,yPos,moveTime,movePattern),
      _numFlowers(numFlowers), _pickTime(pickTime),
      _gameStrategy(gameStrategy){
      if(!Checks<float>::checkPositive(_pickTime)||
	 !legalWeapon(_gameStrategy))
	    throw IllegalEntityException(_order);
}

void Student::setPickTime(float pickTime){
      if(!Checks<float>::checkPositive(pickTime))
	    throw IllegalEntityException(_order);
      _pickTime=pickTime;
}

void Student::setGameStrategy(string gameStrategy){
      if(!legalWeapon(gameStrategy))
	    throw IllegalEntityException(_order);
      _gameStrategy=gameStrategy;
}

ostream& Student::stringFormat(ostream& out)const{
      ostream& tmp = out<< _STUDENT << _SPACE << _OPEN << _SPACE;

      // concating to the string repres. of the movableEntity.
      return (MovableEntity::stringFormat(tmp))
	<< _STUD_NUM_FLOW << _SPACE << _EQUALS << _SPACE << _numFlowers
	<< _SPACE << _PICK_TIME << _SPACE << _EQUALS << _SPACE << _pickTime
	<< _SPACE << _GAME_STRAT << _SPACE << _EQUALS << _SPACE
	<< _gameStrategy << _SPACE << _CLOSE << endl;

}

void Student::encounter(Entity* ent, EncounterManager& enc){
      ent->encounterStudent(this, enc);
}

void Student::encounterStudent(Student* s, EncounterManager& enc){
      enc.encounterStudentAndStudent(this, s);
}

void Student::encounterTeacher(Teacher* t, EncounterManager& enc){
      enc.encounterStudentAndTeacher(this, t);
}

void Student::encounterFlower(Flower* f, EncounterManager& enc){
      enc.encounterStudentAndFlower(this, f);
}

void Student::encounterSeed(Seed* s, EncounterManager& enc){}

void Student::encounterMole(Mole* m, EncounterManager& enc){}

const string Student::_STUDENT = "Student";
const string Student::_STUD_NUM_FLOW = "flowers";
const string Student::_PICK_TIME = "picking-time";
const string Student::_GAME_STRAT = "game-strategy";
 
const string Student::_FIRST_WEAPON = "E";
const string Student::_SECOND_WEAPON = "N";
const string Student::_THIRD_WEAPON = "M";

bool Student::legalWeapon(string str){
      return(str==_FIRST_WEAPON || str==_SECOND_WEAPON ||
	     str==_THIRD_WEAPON);
	          
}

/************************************************************************
			       EOF
*************************************************************************/

