/**
   File name: student.h
   Ex number: Project, part 1
   Login: adiluria
   Name: Adi Luria
   ID: 017651662

   File description: Class defining a student, which inherits from the
   movableEntity class. a student is identified by the num of flowers it
   colleckts, picking-time and its game-strategy in the EVEN-NIAR game.
*/

#ifndef _STUDENT_H
#define _STUDENT_H

/*-------------------------- included files -------------------------*/
#include <iostream.h>
#include <string>
#include "movableEntity.h"

class Student: public MovableEntity{
 public:
      /*------------------- ctors -----------------------------------*/
      /* default ctor. */
      Student(){}

      /* constructs a student inheriting from the movableEntity class.
	 inits the flower related params and those of the EVEN-NIAR game.
       */
      Student(unsigned int order,unsigned int xPos,
	      unsigned int yPos, float moveTime,
	      const string movePattern, unsigned int numFlowers,
	      float pickTime, const string gameStrategy);
	   
      /*---------------------- dtor ---------------------------------*/
      ~Student(){}

      /*-------------------- accessories ----------------------------*/

      /* returns the num of flowers the student has. */
      unsigned int getNumFlowers()const {return(_numFlowers);}

      /* returns the picking time of the student. */
      float getPickTime()const {return(_pickTime);}

      /* returns the game strategy of the student in the game.*/
      string getGameStrategy()const {return(_gameStrategy);}

      /* sets the num of flowers the student has. */
      void setNumFlowers(unsigned int numFlowers){
	    _numFlowers=numFlowers;
      }

      /* sets the picking time of the student. */
      void setPickTime(float pickTime);

      /* sets the game strategy of the student in the game.
	 returns true if the set has succeeded. */
      void setGameStrategy(string gameStrategy);
      
      /* returns the ostream containg the string repres. of the
	 student. */
      virtual ostream& stringFormat(ostream& out)const;
      
      /* defines the generic encounter method of the student. */
      virtual void encounter(Entity* ent, EncounterManager& enc);
      
      /* defines the encounter of this student with a student. */
      virtual void encounterStudent(Student* s, EncounterManager& enc);
      
      /* defines the encounter of this student with a teacher. */
      virtual void encounterTeacher(Teacher* t, EncounterManager& enc);
      
      /* defines the encounter of this student with a flower. */
      virtual void encounterFlower(Flower* f, EncounterManager& enc);
      
      /* defines the encounter of this student with a flower-seed. */
      virtual void encounterSeed(Seed* s, EncounterManager& enc);
      
      /* defines the encounter of this student with a mole-cricket. */
      virtual void encounterMole(Mole* m, EncounterManager& enc);

      // consts defining the string representation of the fields of the
      // student
      static const string _STUDENT;
      static const string _STUD_NUM_FLOW;
      static const string _PICK_TIME;
      static const string _GAME_STRAT;
      
      // the weapons of the EVEN-NIAR game
      static const string _FIRST_WEAPON;
      static const string _SECOND_WEAPON;
      static const string _THIRD_WEAPON;

 private:
      // denotes the number of flowers the student has
      unsigned int _numFlowers;
      // denotes the picking time of the student
      float _pickTime;
      // denotes the game strategy of the student in the EVEN-NIAR game
      string _gameStrategy;
      // determines if the given game-weapon is a legal one.
      bool legalWeapon(string str);
};
#endif

/*************************************************************************
			       EOF
**************************************************************************/

