/**
   File name: teacher.h
   Ex number: Project, part 1
   Login: adiluria
   Name: Adi Luria
   ID: 017651662

   File description: This class defines a teacher. it inherits the
   creature class. A teacher is defined by the number of flowers they
   have, and by their flower greed.
*/
#ifndef _TEACHER_H
#define _TEACHER_H

/*---------------------- included files -------------------------*/
#include <iostream.h>
#include <string>
#include "movableEntity.h"

class Teacher: public MovableEntity{
 public:
      /*-------------------- ctors ------------------------------*/
      /* default ctor. */
      Teacher(){}
      /* constructs a teacher inheriting from the movableEntity class.
	inits the flower related params.
      */
      Teacher(unsigned int order, unsigned int xPos,
	      unsigned int yPos, float moveTime,
	      const string movePattern, unsigned int numFlowers,
	      unsigned int flowerGreed):
	    MovableEntity(order,xPos,yPos,moveTime,movePattern),
	    _numFlowers(numFlowers), _flowerGreed(flowerGreed){
      }

      /*------------------- dtor ------------------------------------*/
      ~Teacher(){}

      /*------------------- accessories -----------------------------*/
      /* gets the num of flowers the teacher has. */
      unsigned int getNumFlowers()const {return(_numFlowers);}

      /* gets the flower greed of the teacher. */
      unsigned int getFlowerGreed()const {return(_flowerGreed);}

      /* sets the num of flowers the teacher has. */
      void setNumFlowers(unsigned int numFlowers){
	    _numFlowers=numFlowers;
      }

      /* sets the flower greed of the teacher. */
      void setFlowerGreed(unsigned int flowerGreed){
	    _flowerGreed=flowerGreed;
      }

      /* returns the ostream containing the string repres. of the
	 teacher. */
      ostream& stringFormat(ostream& out)const;

      /* defines the generic encounter method of the teacher */
      virtual void encounter(Entity* ent, EncounterManager& enc);

      /* defines the encounter of this teacher with a student. */
      virtual void encounterStudent(Student* s, EncounterManager& enc);

      /* defines the encounter of this teacher with a teacher. */
      virtual void encounterTeacher(Teacher* t, EncounterManager& enc);

      /* defines the encounter of this teacher with a flower. */
      virtual void encounterFlower(Flower* f, EncounterManager& enc);

      /* defines the encounter of this teacher with a flower-seed. */
      virtual void encounterSeed(Seed* s, EncounterManager& enc);

      /* defines the encounter of this teacher with a mole-crickets. */
      virtual void encounterMole(Mole* m, EncounterManager& enc);

      // consts defining the string repres. of the fields of the teacher
      static const string _TEACHER;
      static const string _TEACH_NUM_FLOW;
      static const string _FLOW_GREED;
      
 private:
      // denotes the num of flowers
      unsigned int _numFlowers;
      // denotes the flower greed of the teacher
      unsigned int _flowerGreed;
};
#endif

/************************************************************************
			       EOF
*************************************************************************/

